#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>


/* print raw 7 bytes */
void print7(char *buffer){
	unsigned char *unbuf=buffer;
	printf("bytes: %2d,%2d,%2d,%2d,%2d,%2d,%2d\n",
	       buffer[0],buffer[1],buffer[2],buffer[3],buffer[4],buffer[5],buffer[6]);
	printf("    %.2x,%.2x,%.2x,%.2x,%.2x,%.2x,%.2x\n",
	       unbuf[0],unbuf[1],unbuf[2],unbuf[3],unbuf[4],unbuf[5],unbuf[6]);
}


/* *************************************************
 * NOTE:  it seems like the "min" value of accelerator and brake are
 *        non-deterministic. Pick your own values if you like, or
 *        do whatever seems appropriate.
 * **************************************************/
void printstatus(unsigned char *buffer){
	char buttonbuf[100];
	printf("Wheel = %.3d Accel=%.3d Brake=%.3d: ",
	       (char)buffer[0],
	       0xaf - buffer[5], /* Yes, this is wierd */
	       0xdf - buffer[6]  /* Yes, this is wierd */
	       );
	buttonbuf[0]='\0';
	if(buffer[1]&0x80) strcat(buttonbuf,"L1 ");
	if(buffer[1]&0x40) strcat(buttonbuf,"R1 ");
	if(buffer[1]&0x20) strcat(buttonbuf,"Tri ");
	if(buffer[1]&0x10) strcat(buttonbuf,"Cir ");
	if(buffer[1]&0x08) strcat(buttonbuf,"Squ ");
	if(buffer[1]&0x04) strcat(buttonbuf,"X ");

	if(buffer[2]&0x08) strcat(buttonbuf,"START ");
	if(buffer[2]&0x04) strcat(buttonbuf,"SELECT ");
	if(buffer[2]&0x02) strcat(buttonbuf,"L2 ");
	if(buffer[2]&0x01) strcat(buttonbuf,"R2 ");

	/* directional pad: use compass headings as short names */
	switch(buffer[4]&0xf){
		case 0:	strcat(buttonbuf,"D-pad=N "); break;
		case 1:	strcat(buttonbuf,"D-pad=NE "); break;
		case 2:	strcat(buttonbuf,"D-pad=E "); break;
		case 3:	strcat(buttonbuf,"D-pad=SE "); break;
		case 4:	strcat(buttonbuf,"D-pad=S "); break;
		case 5:	strcat(buttonbuf,"D-pad=SW "); break;
		case 6:	strcat(buttonbuf,"D-pad=W "); break;
		case 7:	strcat(buttonbuf,"D-pad=NW "); break;
		/* case 8: nothing pressed */
	}

	printf("%s\n",buttonbuf);

}

int main(int argc, char *argv[]){
	int fd,bytes;
	char buffer[10];
	if(argc<2){
		puts("Need a device name to hold open");
		exit(1);
	}
	fd=open(argv[1],O_RDONLY);
	if(fd<0){
		perror("could not open file");
		exit(1);
	}
	while(1){
	
		read(fd,buffer,7);
		/*print7(buffer);*/
		printstatus(buffer);
	}

	/* NOTREACHED */
	puts("quitting");
	close(fd);
	
}
